/*
 *  groester_platz.rexx
 *
 *  Sucht die Cassette, auf der noch am meisten Platz ist.
 *  Dazu werden sowohl die Daten aus MUIVideo, als auch
 *  aus MUITapes herangezogen. Ist eine Cassette in
 *  MUITapes unbekannt, so wird eine Bandlnge von 0 min
 *  angenommen. Daher ist auf diesem Band nichts mehr frei.
 *
 *  ACHTUNG: Dieses Script nimmt an, das die Cassetten-
 *           nummern dreistellig, mit fhrenden Nullen
 *           sind! Ggf. mu das Script gendert werden.
 *
 *  $VER: differenz.rexx V1.1 (07.01.97)
 *  Copyright by Christoph Kirsch
 *
 */

options results

address MUIVIDEO.1            /* MUIVideo fragen ... */

/*sleep*/

count                         /* ...Wieviele Filme in der Liste sind. */
afilme = result

cmax = 0                      /* Variable fr hchste Cassettennummer */

gauge 0 open                  /* Gauge auf und auf 0 */

do i=0 to afilme-1
  gauge i*100/afilme
  getquick i CASSETTE         /* Cassettennummer abfragen */
  c = result
  if c<'A' then do            /* numerisch? */
    if c>cmax then cmax = c   /* Grte Cassettennummer feststellen */
    end
end

gauge 0                       /* Gauge wieder auf 0 */

do i=0 to cmax                /* Array fr Spielzeiten initialisieren */
  gauge i*100/cmax
  n.i = 0
end

n = 0
a = 0

gauge 0                       /* Gauge wieder auf 0 */

do i=0 to afilme-1            /* Die Liste der Filme durchgehen */

  gauge i*100/afilme

  getquick i CASSETTE         /* Cassettennummer erfragen */
  c = result
  getquick i LAENGE           /* Filmlnge erfragen */
  l = result
  getquick i GESCHWINDIGKEIT  /* Bandgeschwindigkeit erfragen */
  g = result

  a = strip(c,'L','0')        /* Fhrenden Nullen abschneiden */

  if c < 'A' then do
    if g = 0 then do
      n.a = n.a + l
      end
    else do
      n.a = n.a + l/2
      end
    end

end

gauge 0
wake

address MUITAPES.1            /* Jetzt mit Daten in MUITapes vergleichen */

maxfree  = 0
freetape = 0
tapelen  = 0

do i=1 to cmax

  address muivideo.1
  gauge i*100/cmax
  address muitapes.1

  p = length(i)
  tape = overlay(i,'000',4-p)

  findtape tape               /* Ist das Band bekannt? */
  x = result

  if x = "-1" then do         /* wenn noch nicht vorhanden ... */
    free = 0 - n.i            /* ... von einer vollen Cassette ausgehen */
    l = 0
    end
  else do
    gototape x                /* Band auswhlen */
    get LAENGE                /* Bandlnge auslesen */
    r = result
    if r ~= "-1" then do      /* wenn keine Original-Cassette, dann ... */
      l = value(r)
      free = l - n.i          /* freien Platz berechnen */
      end
    else do                   /* wenn Original-Cassette, dann ... */
      free = 0                /* ist die Cassette voll! */
      end
    end

  if free > maxfree then do   /* wenn mehr Platz als bisher */
    maxfree  = free           /* Platz und Nummer merken */
    freetape = i
    tapelen  = l
    end

end

address MUIVIDEO.1            /* MUIVideo zur Anzeige benutzen */

gauge 0 close

text = """" || 'Cassette = ' || freetape || '|Lnge = ' || tapelen || '|davon frei : ' || maxfree || """"

requestnotify text

